/* 
 * 16F88_Ref3_Buzzer
 * PIC16F88]{[hɃuU[tĖ炷vO
 * 
 * File:   main.c
 * Author: Taichi
 *
 * Created on 2017/10/17, 10:16
 */

// CONFIG1
#pragma config FOSC = INTOSCIO  // Oscillator Selection bits (INTRC oscillator; port I/O function on both RA6/OSC2/CLKO pin and RA7/OSC1/CLKI pin)
#pragma config WDTE = OFF       // Watchdog Timer Enable bit (WDT disabled)
#pragma config PWRTE = OFF      // Power-up Timer Enable bit (PWRT disabled)
#pragma config MCLRE = ON       // RA5/MCLR/VPP Pin Function Select bit (RA5/MCLR/VPP pin function is MCLR)
#pragma config BOREN = ON       // Brown-out Reset Enable bit (BOR enabled)
#pragma config LVP = OFF        // Low-Voltage Programming Enable bit (RB3 is digital I/O, HV on MCLR must be used for programming)
#pragma config CPD = OFF        // Data EE Memory Code Protection bit (Code protection off)
#pragma config WRT = OFF        // Flash Program Memory Write Enable bits (Write protection off)
#pragma config CCPMX = RB3      // CCP1 Pin Selection bit (CCP1 function on RB3)
#pragma config CP = OFF         // Flash Program Memory Code Protection bit (Code protection off)

// CONFIG2
#pragma config FCMEN = OFF      // Fail-Safe Clock Monitor Enable bit (Fail-Safe Clock Monitor disabled)
#pragma config IESO = OFF       // Internal External Switchover bit (Internal External Switchover mode disabled)

#include <xc.h>
#include <stdio.h>
#include "uart.h"

#define _XTAL_FREQ 8000000      // 8MHz

#define LED1 RA0 // True ON LED
#define LED2 RA6 // False ON LED
#define SWITCH1 RA1 // Pull Down Switch
#define SWITCH2 RA7 // Pull Up Switch
#define VOLUME RA4 // VR1
#define SENSOR RB4 // Photo Sensor
#define M_IN1 RA2 // H-bridge IN1
#define M_IN2 RA3 // H-bridge IN2
#define TR RB3 // Transistor

#define PR2_DATA 0xFF           // PR2 ݒf[^@PR2͎ݒ 8bit̍őlݒ
#define T2_DIV_BY_1 0b00000000  // T2CON ݒf[^@2bitŃ^C}2vXP[^w 00:vXP[1
#define CCP_PWM 0b00001100      // CCP1CON ݒf[^  0000:00+duty2bit,1100:PWM[h

#define RTCC_INTERNAL 0x00      // pX͓NbNg
#define RTCC_DIV_256 0x00       // vXP[̐ݒl: 1/2 (0b000)
#define TMR0_DATA 0xCE          // TMR0̏l 0xCE=206
int CNT_DATA=22;             // JE^pϐ̏livZ͉Lj
// (1/NbN) * 4 * vXP[ݒl * (255 - (TMR0l - 1))*JE^pϐ̏l : 1ɂ鎞
// (1/8000000*4*2*(255-(206-1)))*22= 0.0011sec :1ɂ鎞

#define TEMPO 120 // e|[bps]

int cnt; // 荞݊֐ŎgpJEgϐ
unsigned int flag=0;

// vg^Cv錾
void tone(char onkai,int octave, int nagasa);
void mk_onkai(float freq);
void initTMR0(unsigned char mode);
void setTMR0(unsigned char tmr0);
void interrupt isrTMR0();

void main(void) {
    
    OSCCON = 0b01110000;    // ?????N???b?N????g????8MHz????
 
    PORTA = 0x00;           // PORTA????????
    PORTB = 0x00;           // PORTB????????
    TRISA = 0b10010010;     // PORTA????o???? RA1,7??SWITCH, RA4??VOLUME
    TRISB = 0b00010100;     // PORTB????o???? RB2??RX, RB4??SENSOR
    ANSEL = 0b00000000;     // AD?R???o?[?^??????
    
    initUART();             // VAʐMݒ
    __delay_ms(100);
   
    cnt = CNT_DATA;             // TMR0݂𗘗p1bJE^pϐ
    initTMR0(RTCC_INTERNAL | RTCC_DIV_256);
    setTMR0(TMR0_DATA);         // TMR0̏lݒ
    TMR0IE = 1;                   // TMR0݂
    GIE = 1;                    // O[o݂
    
    
    while(1){        
      if(SWITCH1==0 && SWITCH2==0){
      // h~t@\Vh
        tone('C',4,1);
        tone('D',4,1);
        tone('E',4,1);
        tone('F',4,1);
        tone('G',4,1);
        tone('A',4,1);
        tone('B',4,1);
        tone('C',5,1);
        tone(' ',0,1);
      }
        
    
      if(SWITCH1==1 && SWITCH2==0){
        // GNgJp[h
        tone('G',4,2);
        
        tone('B',4,4);
        tone('C',5,4);
        tone('D',5,2);
        
        tone('G',4,2);
        
        tone('E',4,2);
        
        tone('A',4,4);
        tone('G',4,4);
        tone('f',4,4);
        tone('E',4,4);
        tone('f',4,4);
        tone('D',4,4);
        
        
        tone('G',4,2);
        
        tone('G',4,4);
        tone('A',4,4);
        tone('B',4,4);
        tone('A',4,4);
        tone('B',4,4);
        tone('G',4,4);
        tone('A',4,4);
        tone('B',4,4);
        tone('A',4,4);
        tone('G',4,4);
        tone('f',4,4);
        tone('E',4,4);
        tone('f',4,4);
        tone('D',4,4);

        
        tone('G',4,2);
        
        tone('B',4,4);
        tone('C',5,4);
        tone('D',5,2);
        
        tone('G',4,2);
        
        tone('E',4,2);
        
        tone('A',4,4);
        tone('G',4,4);
        tone('f',4,4);
        tone('E',4,4);
        tone('f',4,4);
        tone('D',4,4);
        
        
        tone('G',4,4);
        tone('A',4,4);
        tone('B',4,4);
        tone('G',4,4);
        tone('A',4,4);
        tone('B',4,4);
        tone('A',4,4);
        tone('G',4,4);
        tone('f',4,4);
        tone('E',4,4);
        tone('f',4,4);
        tone('D',4,4);
        tone('G',4,4);

        
        tone(' ',0,1);
        tone(' ',0,1);
      }
     
    if(SWITCH1==1 && SWITCH2==1){  
    // 悤Wop[Nw
        tone('F',4,4);
        tone('E',4,4);
        tone('F',4,4);
        tone('G',4,2);
        tone('F',4,4);
        tone('G',4,4);
        tone('A',4,2);
        
        tone('a',4,4);
        tone('B',4,4);
        tone('C',5,2);
        tone('A',4,4);
        tone('G',4,4);
        tone('F',4,4);
        
        tone('F',4,2);
        tone('D',5,2);
        tone('C',5,2);
        tone('F',4,2);
        
        tone('a',4,4);
        tone('A',4,4);
        tone('G',4,4);
        tone('F',4,4);
        tone('G',4,2);
        tone(' ',0,2);
        tone(' ',0,4);
        
        tone('F',4,4);
        tone('E',4,4);
        tone('F',4,4);
        tone('G',4,2);
        tone('F',4,4);
        tone('G',4,4);
        tone('A',4,2);
        
        tone('a',4,4);
        tone('B',4,4);
        tone('C',5,2);
        tone('A',4,4);
        tone('G',4,4);
        tone('F',4,4);
        
        tone('F',4,2);
        tone('D',5,2);
        tone('C',5,2);
        tone('F',4,2);
        
        tone('D',4,2);
        tone('a',4,2);
        tone('A',4,2);
        tone('G',4,2);
        tone('F',4,4);
        tone(' ',0,4);
        tone(' ',0,2);
        tone(' ',0,1);
      }
    }
}



void tone(char onkai,int octave, int nagasa){
    int wait_10ms;
    int i;
    
    TMR0IE = 1;// TMR0݂ĊJ
    if(octave==3){
        if(onkai=='C'){mk_onkai(130.813);}      // h
        else if(onkai=='c'){mk_onkai(138.591);} // h#
        else if(onkai=='D'){mk_onkai(146.832);} // 
        else if(onkai=='d'){mk_onkai(155.563);} // # 
        else if(onkai=='E'){mk_onkai(164.814);} // ~
        else if(onkai=='F'){mk_onkai(174.614);} // t@
        else if(onkai=='f'){mk_onkai(184.997);} // t@#
        else if(onkai=='G'){mk_onkai(195.998);} // \
        else if(onkai=='g'){mk_onkai(207.652);} // \#
        else if(onkai=='A'){mk_onkai(220.000);} // 
        else if(onkai=='a'){mk_onkai(233.082);} // #
        else if(onkai=='B'){mk_onkai(246.942);} // V
    }
    else if(octave==4){
        if(onkai=='C'){mk_onkai(261.626);}      // h
        else if(onkai=='c'){mk_onkai(277.183);} // h#
        else if(onkai=='D'){mk_onkai(293.665);} // 
        else if(onkai=='d'){mk_onkai(311.127);} // # 
        else if(onkai=='E'){mk_onkai(329.628);} // ~
        else if(onkai=='F'){mk_onkai(349.228);} // t@
        else if(onkai=='f'){mk_onkai(369.994);} // t@#
        else if(onkai=='G'){mk_onkai(391.995);} // \
        else if(onkai=='g'){mk_onkai(415.305);} // \#
        else if(onkai=='A'){mk_onkai(440.000);} // 
        else if(onkai=='a'){mk_onkai(466.164);} // #
        else if(onkai=='B'){mk_onkai(493.883);} // V
    }
    else if(octave==5){
        if(onkai=='C'){mk_onkai(523.251);}      // h
        else if(onkai=='c'){mk_onkai(554.365);} // h#
        else if(onkai=='D'){mk_onkai(587.330);} // 
        else if(onkai=='d'){mk_onkai(622.254);} // # 
        else if(onkai=='E'){mk_onkai(659.255);} // ~
        else if(onkai=='F'){mk_onkai(698.456);} // t@
        else if(onkai=='f'){mk_onkai(739.989);} // t@#
        else if(onkai=='G'){mk_onkai(783.991);} // \
        else if(onkai=='g'){mk_onkai(830.609);} // \#
        else if(onkai=='A'){mk_onkai(880.000);} // 
        else if(onkai=='a'){mk_onkai(932.328);} // #
        else if(onkai=='B'){mk_onkai(987.767);} // V
    }
    else {TMR0IE = 0;}  // TMR0݂~
 
    
    wait_10ms=6000/TEMPO/nagasa; // 60/TEMPO[RPM] /nagasa[4] *10
        for(i=0;i<wait_10ms;i++){
        __delay_ms(10);
    }
}

void mk_onkai(float freq){
    CNT_DATA=10000/freq; // 1[sec]/freq[Hz] / 2[On&OFF] / 0.00005[sec]
    printf("%d\n",CNT_DATA);
   // printf("%f\n",freq);
    
}

// ^C}[0荞ݐݒ֐
void initTMR0(unsigned char mode)
{
    OPTION_REG &= 0b11000000; // rbg}XN
    OPTION_REG |= mode; // pX͓orOAvXP[lݒ
    TMR0 = 0x00; // TMR0̃JEgl0ɂ
}
 
// ^C}[0荞ݏlݒ֐
void setTMR0(unsigned char tmr0)
{
    TMR0 = tmr0; // TMR0̏lݒ
}
 
// ^C}[0荞ݔɎs֐
void interrupt isrTMR0() // ISR:Interrupt Service Routine 
{
    TMR0IF = 0;       // TMR0݂NA
    TMR0 = TMR0_DATA; // TMR0JE^JnlăZbg
    cnt--;
    if(cnt == 0){
        cnt = CNT_DATA;         // JE^pϐ
        if(flag==0){
            M_IN1=1;
            M_IN2=0;
            //TR=1;
            flag=1;
        }
        else{
            M_IN1=0;
            M_IN2=1;
            //TR=0;
            flag=0;            
        }
    }
}